/* CS6 - Channel Services src/join_part.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void join(char *who, char *rest)
{
   struct regsinfo *regs;
   char *chan = NULL, *usernum = NULL, test[10000], *nwho = NULL;

   test[0]='\0';
   nwho = nick2num(who);
   usernum=get_usernum(bot.nick);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(chan_check(chan, who) == -1) return;
   if(check(chan, who) == -1) return;
   strlwr(chan);
   regs = return_regsinfo(chan);
   if(regs->suspend)
   {
      send_to_server(":%s NOTICE %s : Channel %s is Suspended\n", bot.nick, nwho, chan);
      return;
   }
   send_to_server(":%s JOIN %s\n", bot.nick, chan);
   add_joininfo(chan, usernum, TRUE, time(NULL));
   send_to_server(":%s MODE %s +o %s\n", myserver, chan, usernum);
   if(deopchan)
      deopall(bot.nick, chan);
   enforce_chan_bans(chan);
   send_to_server(":%s TOPIC %s\n", bot.nick, chan);
   send_to_server(":%s MODE %s\n", bot.nick, chan);
}

void part(char *who, char *rest)
{
   char *chan = NULL, test[10000];

   test[0]='\0';
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(chan_check(chan, who) == -1) return;
   if(check(chan, who) == -1) return;
   strlwr(chan);
   send_to_server(":%s PART %s\n", bot.nick, chan);
   delete_cnode(chan, bot.nick);
}
