/* CS6 - Channel Services src/motd.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void show_welcome(char *who, char *chan)
{
   struct regsinfo *tmp;
   char *nwho = NULL, *ptr = NULL;

   tmp = return_regsinfo(chan);
   if(tmp == NULL) return;
   if(!tmp->setwelc) return;
   if(*tmp->welcome == '\0' || *tmp->welcome == ' ') return;
   nwho = nick2num(who);
   send_to_server(":%s NOTICE %s :Welcome - %s\n", bot.nick, nwho, tmp->welcome);
}

void do_voice(char *who, char *chan)
{
   struct regsinfo *tmp;
   struct userinfo *usertmp;
   char *nwho = NULL;

   tmp = return_regsinfo(chan);
   if(tmp == NULL) return;
   usertmp = return_userinfo(who, chan);
   if(usertmp == NULL) return;
   nwho = nick2num(who);
   if(usertmp->voice == 1)
   {
      send_to_server(":%s MODE %s +v %s\n", bot.nick, chan, nwho);
      return;
   }
   if(!tmp->setvoice) return;
   send_to_server(":%s MODE %s +v %s\n", bot.nick, chan, nwho);
}

void show_motd(char *who, char *chan)
{
   struct regsinfo *tmp;
   char *nwho = NULL, *ptr = NULL;

   tmp = return_regsinfo(chan);
   if(tmp == NULL) return;
   if(*tmp->motd == '\0' || *tmp->motd == ' ' || tmp->motd == NULL) return;
   nwho = nick2num(who);
   send_to_server(":%s NOTICE %s :MOTD for %s - %s\n", bot.nick, nwho, chan, tmp->motd);
}
