/* CS6 - Channel Services src/set_pass.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void new_password(char *who, char *rest)
{
   char *chan, *newpass = NULL, *nwho = NULL, test[10000], *nuhost = NULL, *uhost = NULL, buhost[100], *cryptpass = NULL, *helpname = NULL;
   char *idnick = NULL, *anewpass = NULL;
   struct regsinfo *regs;
   struct userinfo *user, *tmp;
   struct numinfo *num;
   int gotit = 0;

   test[0] = '\0';
   buhost[0] = '\0';
   nwho = nick2num(who);
   tmp = return_userinfo(who, csadminchan);
   strcpy(test, rest);
   chan = strtok(test, " ");
   helpname = get_command_name("newpass");
   if(chan[0] != '#' && tmp != NULL)
   {
      chan = csadminchan;
      idnick = strtok(NULL, " ");
      if(idnick == NULL)
      {
	 do_help(who, helpname);
	 return;
      }
      newpass = strtok(NULL, " ");
      if(newpass == NULL)
      {
	 do_help(who, helpname);
	 return;
      }
   }
   else
   {
      if(chan_check(chan, who) == -1) return;
      if(check(chan, who) == -1) return;
      strlwr(chan);
      idnick = strtok(NULL, " ");
      if(idnick == NULL)
      {
	 do_help(who, helpname);
	 return;
      }
      newpass = strtok(NULL, " ");
      if(newpass == NULL)
      {
	 do_help(who, helpname);
	 return;
      }
   }
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(regs->channel, chan))
      {
	 user = regs->userhead;
	 while(user != NULL)
	 {
	    num = user->numhead;
	    while(num != NULL)
	    {
	       if(!strcmp(nwho, num->numeric) && !strcasecmp(idnick, user->nick))
	       {
		  cryptpass = mkpass(newpass, "0");
		  strcpy(user->password, cryptpass);
		  write_single_channel(chan);
		  send_to_server(":%s NOTICE %s :Password Changed\n", bot.nick, nwho);
		  return;
	       }
	       num = num->next;
	    }
	    user = user->next;
	 }
      }
      regs = regs->next;
   }
   send_to_server(":%s NOTICE %s :Password NOT Changed\n", bot.nick, nwho);
}
