/* CS6 - Channel Services src/kickban.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void kick_ban(char *who, char *rest)
{
   struct userinfo *tmp, *usertmp, *admn, *admntmp;
   struct regsinfo *regs;
   struct nickinfo *tmp1, *tmp4;
   struct chaninfo *tmp2;
   struct authinfo *admnauth, *userauth, *tmp3;
   char *nick = NULL, *level = NULL, *chan = NULL, *tlevel = NULL, *nnwho = NULL, *uhost = NULL;
   char test[10000], *therest = NULL, newban[1000], *nwho = NULL, *banmask = NULL, *waste = NULL, *tnick = NULL, *helpname = NULL;

   char *foobar = NULL, test2[1000], *testtime = NULL;

   test[0]='\0';
   newban[0]='\0';
   nwho = nick2num(who);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(chan_check(chan, who) == -1) return;
   if(check(chan, who) == -1) return;
   admn = return_userinfo(who, csadminchan);
   tmp = return_userinfo(who, chan);
   helpname = get_command_name("kickban");
   if(level = strchr(rest, ' '))
   {
      *level++ = '\0';
      tlevel = strtok(NULL, " ");
      if(is_num(tlevel))
      {
	 if(nick = strchr(level, ' '))
	 {
	    *nick++ = '\0';
	    tnick = strtok(NULL, " ");
	    if(strchr(tnick, '!') || strchr(tnick, '@'))
	    {
	       do_help(who, helpname);
	       return;
	    }
	    if(!strcasecmp(nick, bot.nick))
	    {
	       send_to_server(":%s NOTICE %s : Now you went and did it, I'm leaving and not coming back\n", bot.nick, nwho);
	       send_to_server(":%s PART %s\n", bot.nick, chan);
	       return;
	    }
	    if(therest = strchr(nick, ' ')) *therest++ = '\0';
	    else
	       therest = NULL;
	    if(uhost = getuserhost(nick));
	    if(uhost == NULL)
	    {
	       send_to_server(":%s NOTICE %s : User is not currently online\n", bot.nick, nwho);
	       return;
	    }
	    banmask = get_ban_mask(uhost);
	    if(therest != NULL)
	       sprintf(newban, "%s %s %s %s", chan, level, banmask, therest);
	    else
	       sprintf(newban, "%s %s %s", chan, level, banmask);
	    usertmp = return_userinfo(banmask, chan);
	    admntmp = return_userinfo(banmask, csadminchan);
	    userauth = return_authinfo(chan, nick);
	    admnauth = return_authinfo(csadminchan, nick);
	    if(admntmp != NULL && admntmp->protect && admnauth != NULL && strcasecmp(who, bot.nick))
	    {
	       send_to_server(":%s NOTICE %s : That mask matches a protected admin\n", bot.nick, nwho);
	       return;
	    }
	    else if(usertmp != NULL && usertmp->protect && userauth != NULL && strcasecmp(who, bot.nick))
	    {
	       send_to_server(":%s NOTICE %s : That mask matches a protected user\n", bot.nick, nwho);   
	       return;
	    }
	    ban(who, newban);
	    nnwho=nick2num(nick);

	    if (therest != NULL)
	    {
	       strcpy(test2, therest);
	       testtime = strtok(test2, " ");
	       if(strchr(testtime, ':'))
	       {
		  if(foobar = strchr(therest, ' ')) *foobar++ = '\0';
		  send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, foobar);
	       }
	       else
	       {
		  send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, therest);
	       }
	    }
	    else
	    {
	       send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, reason);
	    }
	    tmp1 = nickhead;
	    while(tmp1 != NULL)
	    {
	       tmp2 = tmp1->chanhead;
	       while(tmp2 != NULL)
	       {
		  if(!strcasecmp(chan, tmp2->channel))
		  {
		     tmp3 = return_authinfo(chan, tmp1->nick);
		     if(tmp3 != NULL && tmp2->is_ops)
			send_to_server(":%s NOTICE %s : X has kickbanned %s from %s ( %s [%s])\n", bot.nick, tmp1->numeric, nick, chan, reason, who);
		  }
		  tmp2 = tmp2->next;
	       }
	       tmp1 = tmp1->next;
	    }
	 }
	 else
	 {
	    do_help(who, helpname);
	    return;
	 }
      }
      else
      {
	 if(strchr(tlevel, '!') || strchr(tlevel, '@'))
	 {
	    do_help(who, helpname);
	    return;
	 }
	 if(therest = strchr(level, ' ')) *therest++ = '\0';
	 else
	    therest = NULL;
	 if(!strcasecmp(level, bot.nick))
	 {
	    send_to_server(":%s NOTICE %s : Now you went and did it, I'm leaving and not coming back\n", bot.nick, nwho);
	    send_to_server(":%s PART %s\n", bot.nick, chan);
	    return;
	 }
	 if(uhost = getuserhost(level));
	 if(uhost == NULL)
	 {
	    send_to_server(":%s NOTICE %s : User is not currently online\n", bot.nick, nwho);
	    return;
	 }
	 banmask = get_ban_mask(uhost);
	 if(therest != NULL)
	    sprintf(newban, "%s %s %s", chan, banmask, therest);
	 else
	    sprintf(newban, "%s %s", chan, banmask);
	 usertmp = return_userinfo(banmask, chan);
	 admntmp = return_userinfo(banmask, csadminchan);
	 userauth = return_authinfo(chan, level);
	 admnauth = return_authinfo(csadminchan, level);
	 if(admntmp != NULL && admntmp->protect && admnauth != NULL && strcasecmp(who, bot.nick))
	 {  
	    send_to_server(":%s NOTICE %s : That mask matches a protected admin\n", bot.nick, nwho);
	    return;
	 }	   
	 else if(usertmp != NULL && usertmp->protect && userauth != NULL && strcasecmp(who, bot.nick))
	 {  
	    send_to_server(":%s NOTICE %s : That mask matches a protected user\n", bot.nick, nwho);                        
	    return;
	 }
	 ban(who, newban);
	 nnwho=nick2num(level);
	 if (therest != NULL)
	 {
	    strcpy(test2, therest);
	    testtime = strtok(test2, " ");
	    if(strchr(testtime, ':'))
	    {
	       if(foobar = strchr(therest, ' ')) *foobar++ = '\0';
	       send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, foobar);
	    }
	    else
	    {
	       send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, therest);
	    }
	 }
	 else
	 {
	    send_to_server(":%s KICK %s %s :%s\n", bot.nick, chan, nnwho, reason);
	 }
	 tmp1 = nickhead;
	 while(tmp1 != NULL)
	 {
	    tmp2 = tmp1->chanhead;
	    while(tmp2 != NULL)
	    {
	       if(!strcasecmp(chan, tmp2->channel))
	       {
		  tmp3 = return_authinfo(chan, tmp1->nick);
		  if(tmp3 != NULL && tmp2->is_ops)
		     send_to_server(":%s NOTICE %s : X has kickbanned %s from %s ( %s [%s])\n", bot.nick, tmp1->numeric, level, chan, reason, who);
	       }
	       tmp2 = tmp2->next;
	    }
	    tmp1 = tmp1->next;
	 }
      }
   }
   else
   {
      do_help(who, helpname);
      return;
   }
}
