/* CS6 - Channel Services src/nickban.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void nickban(char *who, char *rest)
{
   char *uhost = NULL, *nick = NULL, *level = NULL, *chan = NULL, *tlevel = NULL;
   char test[10000], *therest = NULL, newban[1000], *nwho = NULL, *banmask = NULL, *helpname = NULL;

   test[0]='\0';
   newban[0]='\0';
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(chan_check(chan, who) == -1) return;
   if(check(chan, who) == -1) return;
   helpname = get_command_name("nickban");
   if(level = strchr(rest, ' '))
   {
      *level++ = '\0';
      tlevel = strtok(NULL, " ");
      if(is_num(tlevel))
      {
	 if(nick = strchr(level, ' '))
	 {
	    *nick++ = '\0';
	    if(strchr(nick, '!') || strchr(nick, '@'))
	    {
	       do_help(who, helpname);
	       return;
	    }
	    if(therest = strchr(nick, ' ')) *therest++ = '\0';
	    else
	       therest = NULL;
	    if(uhost = getuserhost(nick));
	    if(uhost == NULL)
	    {
	       send_to_server(":%s NOTICE %s : User is not currently online\n", bot.nick, nwho);
	       return;
	    }
	    banmask = get_ban_mask(uhost);
	    if(therest != NULL)
	       sprintf(newban, "%s %s %s %s", chan, level, banmask, therest);
	    else
	       sprintf(newban, "%s %s %s", chan, level, banmask);
	    ban(who, newban);
	 }
	 else
	 {
	    do_help(who, helpname);
	    return;
	 }
      }
      else
      {
	 if(strchr(level, '!') || strchr(level, '@'))
	 {
	    do_help(who, helpname);
	    return;
	 }
	 if(therest = strchr(level, ' ')) *therest++ = '\0';
	 else
	    therest = NULL;
	 uhost = getuserhost(level);
	 if(uhost == NULL)
	 {
	    send_to_server(":%s NOTICE %s : User is not currently online\n", bot.nick, nwho);
	    return;
	 }
	 banmask = get_ban_mask(uhost);
	 if(therest != NULL)
	    sprintf(newban, "%s %s %s", chan, banmask, therest);
	 else
	    sprintf(newban, "%s %s", chan, banmask);
	 ban(who, newban);
      }
   }
   else
   {
      do_help(who, helpname);
      return;
   }
}
