/* CS6 - Channel Services src/num_tools.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void serv_unused(char *server)
{
   int i = 0;

   for(i=0;i<NUMNICKBASE;i++)
   {
      if(!strcasecmp(server,servinfo[i].server))
      {
	 servinfo[i].used = FALSE;
	 return;
      }
   }
}

void serv_used(char chars, char *server)
{
   int i = 0;

   for(i=0;i<NUMNICKBASE;i++)
   {
      if(chars == servinfo[i].chars)
      {
	 servinfo[i].used = TRUE;
	 strcpy(servinfo[i].server, server);
	 return;
      }
   }
}

void delete_usernum(char *numeric)
{
   int i = 0;

   for(i=0;i<MAXNUM;i++)
   {
      if(!strcmp(numeric, usernums[i].chars))
      {
	 usernums[i].used=FALSE;
	 return;
      }
   }
}

char *num2serv(char num)
{
   int i = 0;
   char *entry=(char *)NULL;

   for(i=0;i<NUMNICKBASE;i++)
   {
      if(num == servinfo[i].chars)
      {
	 entry=servinfo[i].server;
	 break;
      }
   }
   return(entry);
}

char *nick2num(char *who)
{
   struct nickinfo *current;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(who, current->nick))
      {
	 return(current->numeric);
      }
      current=current->next;
   }
   return NULL;
}

char *num2nick(char *num)
{
   struct nickinfo *current;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcmp(num, current->numeric))
      {
	 return(current->nick);
      }
      current=current->next;
   }
   return NULL;
}

char get_free_servnum(char *server, char numeric)
{ 
   int i = 0;
   char entry=(char)NULL;

   for(i=0;i<NUMNICKBASE;i++) 
   { 
      if ( servinfo[i].used == FALSE && servinfo[i].chars == numeric)
      { 
	 servinfo[i].used = TRUE;
	 strcpy(servinfo[i].server, server);
	 entry=servinfo[i].chars;
	 break;
      }
   }
   return(entry);
}

char *get_free_usernum(char *nick)
{ 
   int i = 0;
   char *entry=(char *)NULL;

   for(i=0;i<MAXNUM;i++) 
   {
      if(usernums[i].used == FALSE)
      {
	 strcpy(usernums[i].nick, nick);
	 usernums[i].used = TRUE;
	 entry=usernums[i].chars;
	 break;
      }
   }
   return(entry);
}

char *get_usernum(char *nick)
{
   int i = 0;
   char *entry=(char *)NULL;

   for(i=0;i<MAXNUM;i++)
   {
      if(!strcasecmp(usernums[i].nick, nick))
      {
	 entry=usernums[i].chars;
	 break;
      }
   }
   return(entry);
}
