/* CS6 - Channel Services src/parse_server.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_server(char *who, char *rest)
{
   struct hubinfo *new;
   char *link = NULL, *server = NULL;

   if(rest == NULL) return;
   link = strtok(rest, " ");
   server=num2serv(*who);
   if(joined)
   {
      free_maplist();
      end_map = 0;
      send_to_server(":%s MAP\n", bot.nick);
   }
   new = (struct hubinfo *) calloc(1, sizeof(struct hubinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->main, server);
      strcpy(new->link, link);
      if(hubhead == NULL)
      {
	 hubhead = new;
	 hubtail = new;
	 hubhead->prev=NULL;
      }
      else
      {
	 new->prev=hubtail;
	 hubtail->next = new;
	 hubtail=new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding new Hub/Link: Out of memory\n", date());
}

